package edu.columbia.cs.irt.sipcloud;

import com.amazonaws.services.ec2.model.InstanceType;


public class Constants {
	
	public static String keyname = "heartshapedkey";
	public static String securityGroup = "sipcloud";
	
	
	public static String sshUser = "ec2-user";
	public static String sipDomain = "sip.epic911.net";
	
	//public static String imageId = "ami-730bc51a";
	public static String imageId = "ami-da64b8b3";	// allows multiple cassandra instances
	public static InstanceType instanceType = InstanceType.T1Micro;		// Instance Type
	//public static InstanceType instanceType = InstanceType.M1Small;		// Instance Type
	//public static InstanceType instanceType = InstanceType.M1Large;		// Instance Type
	public static String ec2UsEast = "ec2.us-east-1.amazonaws.com";
	public static String ec2UsWest = "ec2.us-west-2.amazonaws.com";
	
	public static String confImageId = "ami-0bfa1d62";
	public static InstanceType confInstanceType = InstanceType.M1Small;		
	public static String confSshUser = "root";
	
	public static String imageId_uswest2 = "ami-943bb6a4";		// us-west-2 AMI: cassandra/proxy/LB/relay
	public static String confImageId_uswest2 = "ami-a0199490";	// us-west-2 AMI: asterisk
	
	public static enum VmTypes {
		PROXY, LB, DB, RELAY, CONFERENCE;		// The order of these elements matter a lot!!!!!!!!!!! 
												// VMs started in reverse-order. CONF -> RELAY -> DB -> LB -> PROXY
		
		public static VmTypes getVmType(int ordinal) throws Exception {
			switch (ordinal) {
			case 0:
				return PROXY;
			case 1:
				return LB;
			case 2:
				return DB;
			case 3:
				return RELAY;
			case 4:
				return CONFERENCE;
			}	
			// if not any of the above, we're screwed.
			Exception e = new Exception("Integer out of bounds for VmType!");
			throw e;
		}
	}
	
	public static final double MAX_LOAD_SER = 200.0;
	public static final double MAX_LOAD_LB = 5000.0;
	
	public static final double SCALE_UP_THRESHOLD_SER = 0.85;
	public static final double SCALE_DOWN_THRESHOLD_SER = 0.5;
	
	public static final int MAX_NUM_SER = 4;
	public static final int MAX_NUM_LB = 1;
	
	public static final String TYPE_CONF = "conf";
	public static final String TYPE_CASS = "cassandra";
	public static final String TYPE_SER = "ser";
	public static final String TYPE_LB = "lb";
	public static final String TYPE_RELAY = "relay";
	public static final String TYPE_NA = "unknown";
	
	public static final String TAG_TYPE = "Type";
	public static final String TAG_SEED = "Seed";
	
	public static final String CMD_ADD_PROXY = "Add Proxy";
	public static final String CMD_RMV_PROXY = "Remove Proxy";
	public static final String CMD_ADD_LB = "Add Load Balancer";
	public static final String CMD_RMV_LB = "Remove Load Balancer";
	
	public static final long POLL_INTERVAL = 3000;	// 3 seconds

	public static long vmBootTime = 10000;	// 10 seconds
	
	public static final String SER_PORT = "5062";
	public static final String relayPort = "20679";
	public static final String conferencePort = "5060";
	public static final String cassPort = "9160";


	public static String privKeyFile = "key/heartshapedkey.pem";	// key file from EC2
	
	public static String logFileName = "java-%u.log";
	
	public static String localConfDir = "conf/";		// dir to store config templates
	public static String serConfigFileName = "ser.cfg";
	public static String lbConfigFileName = "ser-lb.cfg";
	public static String cassConfigFileName = "cassandra.yaml";
	public static String cass108ConfigFileName = "cassandra108.yaml";
	public static String dispatchListFileName = "dispatcher.list";
	public static String astSipConfigFileName = "asterisk_sip.conf";
	public static String astRemoteSipConfigFileName = "sip.conf";
	public static String templateExtension = ".temp";
	public static String astScriptFileName = "astConfig.sh";
	
	
	public static String remoteSerConfigDirPath = "/home/ec2-user/sip-router/";
	public static String remoteLbConfigDirPath = "/home/ec2-user/sip-router/";
	public static String remoteCassConfigDirPath = "/home/ec2-user/apache-cassandra-1.0.8/conf/";
	public static String remoteAstConfigDirPath = "/etc/asterisk/";
	
	
	//public static String privKeyFile = "Z:\\ec2\\irtkey.pem";	// key file from EC2
	//public static String dispatchListFileName = "C:\\Users\\jyk\\workspace\\LoadScalingManager\\cmd\\dispatcher.list";
	//public static String logFileName = "C:\\Users\\jyk\\workspace\\LoadScalingManager\\java-%u.log";
	
	public static int UIThreadJob_LB_StartCluster = 0;
	public static int UIThreadJob_LB_StopCluster = 1;
	public static int UIThreadJob_LB_StartInstance= 2;
	public static int UIThreadJob_LB_StopInstance = 3;
	public static int UIThreadJob_LB_ReConfigInstance = 4;
	
}




