package edu.columbia.cs.irt.sipcloud;

public class DnsHandler {
	
	MysqlConnector connector = null;
	
	public DnsHandler() {
		connector = new MysqlConnector();
		connector.connect();
	}
	
	public boolean addLb(String lbName, String lbAddr, String lbPort) {
		return connector.insertLBrecord(lbName, lbAddr, lbPort);
	}
	
	public boolean removeLb(String lbName) {
		return connector.deleteLBrecord(lbName);
	}
	
	public boolean reconnect() {
		connector.close();
		return connector.connect();
	}
	
	public String hyphenateAddress(String address) {
		return address.replaceAll("\\.", "-");
	}
	
	// make a DNS name using LB's public IP address
	public String nameOfLB(String address) {
		return hyphenateAddress(address) + "." + Constants.sipDomain;
	}
}
